<template>
    <div class="mt-4">
        <div>
            <b-modal ref="putmodal" hide-footer id="modal-1" title="BootstrapVue">
                <div class="form-group">
                    <form method="put" @submit.prevent="putUnterrichtsTag(unterrichtsTagUpdate)">
                        <label for="">Wochentag wählen</label>
                        <select class="form-control form-select-lg mb-3" name="Wochentag" id=""
                            v-model="unterrichtsTagUpdate.tageEnums">
                            <option value="MONTAG">Montag</option>
                            <option value="DIENSTAG">Dienstag</option>
                            <option value="MITTWOCH">Mittwoch</option>
                            <option value="DONNERSTAG">Donnerstag</option>
                            <option value="FREITAG">Freitag</option>
                        </select>
                        <label for="">Fach wählen</label>
                        <select class="form-control form-select-lg mb-3" name="TrainerAnstellung" id=""
                            v-model="unterrichtsTagUpdate.fachId">
                            <option v-for="(fach, id) in alleFaecher" :key='id' :value="fach.id">{{ fach.fachUnterricht }},
                                {{ fach.fachBezeichnung }}</option>
                        </select>
                        <label for="">Gruppe wählen</label>
                        <select class="form-control form-select-lg mb-3" name="TrainerAnstellung" id=""
                            v-model="unterrichtsTagUpdate.gruppeId">
                            <option v-for="(gruppe, id) in alleGruppen" :key='id' :value="gruppe.id">{{ gruppe.artDerAusbildung }}{{ gruppe.gruppenNummer }}</option>
                        </select>
                        <label for="">Trainer wählen</label>
                        <select class="form-control form-select-lg mb-3" name="TrainerAnstellung" id=""
                            v-model="unterrichtsTagUpdate.trainerId">
                            <option v-for="(trainer, id) in alleTrainer" :key='id' :value="trainer.id">{{ trainer.name }} | {{ trainer.fachEnums }}</option>
                        </select>
                        <button type="submit" class="btn container-fluid btn-info">Speichern</button>
                    </form>
                </div>

            </b-modal>
        </div>

        <table class="table">
            <th>ID</th>
            <th>Wochentag</th>
            <th>Fach</th>
            <th>Gruppe</th>
            <th>Trainer</th>
            <th></th>
            <tr v-for="(unterrichtsTag, id) in alleUnterrichtsTage" :key='id'>
                <td>{{ unterrichtsTag.id }}</td>
                <td>{{ unterrichtsTag.tage }}</td>
                <td>
                    <table class="table thead-light">
                        <th>Unterricht</th>
                        <th>Thema</th>
                        <tr>
                            <td>{{ unterrichtsTag.fach.fachUnterricht }}</td>
                            <td>{{ unterrichtsTag.fach.fachBezeichnung }}</td>
                        </tr>
                    </table>
                </td>
                <td>
                    <table class="table thead-light">
                        <th>Name</th>

                        <tr>
                            <td>{{ unterrichtsTag.gruppe.artDerAusbildung }}{{ unterrichtsTag.gruppe.gruppenNummer }}</td>
                        </tr>
                    </table>
                </td>
                <td>
                    <table class="table thead-light">
                        <th>Name</th>
                        <th>ID</th>
                        <tr>
                            <td>{{ unterrichtsTag.trainerIn.name }}</td>
                            <td>{{ unterrichtsTag.trainerIn.id }}</td>
                        </tr>
                    </table>
                </td>
                <td>
                    <button type="button" class="btn btn-danger m-1"
                        @click="deleteUnterrichtsTag(unterrichtsTag.id)">X</button>
                    <button type="button" class="btn btn-primary m-1" v-b-modal.modal-1
                        @click="editUnterrichtsTag(unterrichtsTag)">O</button>
                </td>
            </tr>
        </table>
    </div>
</template>

<script>


export default {
    name: 'UnterrichtSeite',
    data() {
        return {

            unterrichtsTagUpdate: {
                tageEnums: '',
                trainerId: '',
                fachId: '',
                gruppeId: '',
                id: ''
            }
        };
    },

    computed: {
        alleUnterrichtsTage() {
            return this.$store.state.alleUnterrichtsTage
        },

        alleFaecher() {
            return this.$store.state.alleFaecher
        },

        alleTrainer() {
            return this.$store.state.alleTrainer;
        },

        alleGruppen() {
            return this.$store.state.alleGruppen;
        },
    },

    mounted() {
        this.$store.dispatch('getAlleUnterrichtsTage');
        this.$store.dispatch("getAlleTrainer");
        this.$store.dispatch("getAlleFaecher");
        this.$store.dispatch("getAlleGruppen");
    },

    components: {
    },

    methods: {

        async deleteUnterrichtsTag(id) {
            const deleteUnterrichtsTag = this.$store.dispatch('deleteUnterrichtsTag', id)
            console.log(deleteUnterrichtsTag)
        },

        async editUnterrichtsTag(unterrichtsTag) {
            this.unterrichtsTagUpdate.tageEnums = unterrichtsTag.tageEnums;
            this.unterrichtsTagUpdate.trainerId = unterrichtsTag.trainerId;
            this.unterrichtsTagUpdate.fachId = unterrichtsTag.fachId;
            this.unterrichtsTagUpdate.gruppeId = unterrichtsTag.gruppeId;
            this.unterrichtsTagUpdate.id = unterrichtsTag.id;
        },

        async putUnterrichtsTag(unterrichtsTagUpdate) {
            console.log(unterrichtsTagUpdate.id)
            this.$store.dispatch("putUnterrichtsTag", this.unterrichtsTagUpdate)
            this.hideModal();
        },

        hideModal() {
            this.$refs['putmodal'].hide();
        }
    }




}
</script>